package ChannelIDS;

use strict;
use Carp;
use warnings;

use IO::File;

use XML::LibXML;

require Channel;

sub load {
	my $self = shift;
	confess "usage: ChannelIDS->load(file)"    unless @_ == 1;

	my $file = shift;

	my $fd = new IO::File;
	if ($fd->open($file, "r")) {
		my @data = <$fd>;
		foreach my $line (@data) {
			chomp($line);
			if (substr($line, 0, 1) ne "#") {
				my @tokens = split('\|', $line);
				my $xmltvid = $tokens[0];
				my $ukrtid = $tokens[1];
				my $altname = $tokens[2];
				my $iconurl = $tokens[3];
				my $ch = Channel->findByXMLTVID($xmltvid);
				if (ref($ch)) {
					print "found " , $altname . " by xmltvid\n";
					$ch->ukrtid($ukrtid);
					$ch->altname($altname);
					$ch->iconurl($iconurl);
				} else {
					$ch = Channel->findByName($altname);
					if (ref($ch)) {
						print "found " . $altname . " by name\n";
						$ch->ukrtid($ukrtid);
						$ch->altname($altname);
						$ch->iconurl($iconurl);
					} else {
						$ch = Channel->findByLongname($altname);
						if (ref($ch)) {
							print "found " . $altname. "  by longname\n";
							$ch->ukrtid($ukrtid);
							$ch->altname($altname);
							$ch->iconurl($iconurl);
						} else {
							print "didn't find " . $altname . " \n";
							$ch = Channel->new();
							$ch->name($altname);
							$ch->longname($altname);
							$ch->ukrtid($ukrtid);
							$ch->altname($altname);
							$ch->iconurl($iconurl);
						}
					}
				}
		    }
		}
		$fd->close;
	}
}

1;
