package ChannelTable;

use strict;
use Carp;
use warnings;

use IO::File;

require Channel;
require ProviderInfo;
require TunerInfo;
require ExternalTunerInfo;
require AnalogueTunerInfo;
require DVB_STunerInfo;

sub store {
	my $self = shift;
	confess "usage: ChannelTable->store(file)"    unless @_ == 1;
	my $file = shift;

	my $fh = new IO::File;
	if ($fh->open($file, "w")) {
		my $count = 2101;
		my @cl = Channel->listOfChannels();
		foreach my $ch (@cl) {
			my $channel_name = $ch->name();
			my $channel_longname = $ch->longname();
			my $channel_icon = Channel->iconprefix() . $ch->icon();
			my $channel_xmltvid = $ch->xmltvid();
			my @providerinfo = @{$ch->providerinfo()};
			foreach my $pi (@providerinfo) {
				my $pi_channelnumber = $pi->channelnumber();
				my $pr = Provider->findByName($pi->name());
				my $provider_tuner = $pr->tuner();
				my $provider_chanid = $pr->chanid();
				my $channel_number = $pi_channelnumber + $provider_chanid;
				if ($provider_tuner eq 'external') {
					my $external_epgnumber = $pi->tunerinfo()->epgnumber();
					print $fh "INSERT INTO \`channel\` VALUES ($count,'$channel_number','$channel_number',2,\'$channel_name\',\'$channel_longname\',\'$channel_icon\',0,\'\',\'$channel_xmltvid\',0,32768,32768,32768,32768,\'Default\',0,1,\'\',NULL,NULL,0,NULL,0,0,0);\n";
	#			} elsif ($provider_tuner eq 'analogue') {
	#				my $analogue_frequency = $pi->tunerinfo()->frequency();
	#				print $fh "INSERT INTO \`channel\` VALUES ($count,'$channel_number','$channel_number',2,\'$channel_name\',\'$channel_longname\',\'$channel_icon\',0,\'\',\'$channel_xmltvid\',0,32768,32768,32768,32768,\'Default\',0,1,\'\',NULL,NULL,0,NULL,0,0,0);\n";
	#			} elsif ($provider_tuner eq 'dvb_s') {
	#				my $dvb_s_mplexid = $pi->tunerinfo()->mplexid();
	#				my $dvb_s_serviceid = $pi->tunerinfo()->serviceid();
	#				my $dvb_s_useonairguide = $pi->tunerinfo()->useonairguide();
	#				print $fh "INSERT INTO \`channel\` VALUES ($count,'$channel_number','$channel_number',2,\'$channel_name\',\'$channel_longname\',\'$channel_icon\',0,\'\',\'$channel_xmltvid\',0,32768,32768,32768,32768,\'Default\',0,1,\'\',NULL,NULL,0,NULL,0,0,0);\n";
				}
				$count++;
			}
		}
	$fh->close;
	}
}

1;
