package DVB_STunerInfo;

use TunerInfo;
@ISA = qw(TunerInfo);

use strict;
use Carp;
use warnings;

my $Debugging = 0;

# the object constructor

sub new {
	my $class = shift;
	my $self  = $class->SUPER::new();
	$self->{MPLEXID}   = "";
	$self->{SERVICEID} = "";
	$self->{USEONAIRGUIDE}   = "";
	bless ($self, $class);
	return $self;
}

# methods to access per-object data
#
# With args, they set the value.  Without
# any, they only retrieve it/them.

sub mplexid {
	my $self = shift;
	if (@_) { $self->{MPLEXID} = shift }
	return $self->{MPLEXID};
}

sub serviceid {
	my $self = shift;
	if (@_) { $self->{SERVICEID} = shift }
	return $self->{SERVICEID};
}

sub useonairguide {
	my $self = shift;
	if (@_) { $self->{USEONAIRGUIDE} = shift }
	return $self->{USEONAIRGUIDE};
}

sub toString {
	my $self = shift;
	return "{" .
		" type=\"" . $self->{TYPE} . "\"" .
		" mplexid=\"" . $self->{MPLEXID} . "\"" .
		" serviceid=\"" . $self->{SERVICEID} . "\"" .
		" useonairguide=\"" . $self->{USEONAIRGUIDE} . "\"" .
		" }";
}

sub debug {
	my $self = shift;
	confess "usage: thing->debug(level)"    unless @_ == 1;
	my $level = shift;
	if (ref($self))  {
		$self->{"_DEBUG"} = $level;         # just myself
	} else {
		$Debugging        = $level;         # whole class
	}
	$self->SUPER::debug($Debugging);
}

sub DESTROY {
	my $self = shift;
	if ($Debugging || $self->{"_DEBUG"}) {
		carp "Destroying $self " . $self->name;
	}
}

sub END {
	if ($Debugging) {
		print "All persons are going away now.\n";
	}
}

1;  # so the require or use succeeds
