package DVB_STunerInfoXML;

use strict;
use Carp;
use warnings;

use XML::LibXML;

require DVB_STunerInfo;

# the object constructor

sub new {
	my $class = shift;
	my $self  = {};
	$self->{NAME}   = "";
	bless ($self, $class);
	return $self;
}

# methods to access per-object data
#
# With args, they set the value.  Without
# any, they only retrieve it/them.

sub name {
	my $self = shift;
	if (@_) { $self->{NAME} = shift }
	return $self->{NAME};
}

sub load {
	my $self = shift;
	confess "usage: DVB_STunerInfoXML->load(node)"    unless @_ == 2;
	my $node = shift;
	my $ti = shift;

	$ti->type($self->{NAME});
	$ti->mplexid($node->findvalue('tunerinfo/mplexid'));
	$ti->serviceid($node->findvalue('tunerinfo/serviceid'));
	$ti->useonairguide($node->findvalue('tunerinfo/useonairguide'));
}

1;
