package ProviderInfo;

require TunerInfo;

use strict;
use Carp;
use warnings;

my $Debugging = 0;

# the object constructor

sub new {
	my $class = shift;
	my $self  = {};
	$self->{NAME}   = "";
	$self->{CHANNELNUMBER}    = "";
	$self->{TUNERINFO}    = TunerInfo->new();;
	bless ($self, $class);
	return $self;
}

# methods to access per-object data
#
# With args, they set the value.  Without
# any, they only retrieve it/them.

sub name {
	my $self = shift;
	if (@_) { $self->{NAME} = shift }
	return $self->{NAME};
}

sub channelnumber {
	my $self = shift;
	if (@_) { $self->{CHANNELNUMBER} = shift }
	return $self->{CHANNELNUMBER};
}

sub tunerinfo {
	my $self = shift;
	if (@_) { $self->{TUNERINFO} = shift }
	return $self->{TUNERINFO};
}

sub toString {
	my $self = shift;
	return "{" .
		" name=\"" . $self->{NAME} . "\"" .
		" channelnumber=\"" . $self->{CHANNELNUMBER} . "\"" .
		" tunerinfo=\"" . $self->{TUNERINFO}->toString() . "\"" .
		" }";
}

sub debug {
	my $self = shift;
	confess "usage: thing->debug(level)"    unless @_ == 1;
	my $level = shift;
	if (ref($self))  {
		$self->{"_DEBUG"} = $level;         # just myself
	} else {
		$Debugging        = $level;         # whole class
	}
}

sub DESTROY {
	my $self = shift;
	if ($Debugging || $self->{"_DEBUG"}) {
		carp "Destroying $self " . $self->name;
	}
}

sub END {
	if ($Debugging) {
		print "All persons are going away now.\n";
	}
}

1;  # so the require or use succeeds
