package ProviderXML;

use strict;
use Carp;
use warnings;

use XML::LibXML;

require Provider;

sub load {
	my $self = shift;
	confess "usage: ProviderXML->load(node)"    unless @_ == 1;
	my $node = shift;
	my @providers = $node->getElementsByTagName('provider');

	foreach my $provider (@providers) {
		my $pr = Provider->new();
		$pr->name($provider->findvalue('@name'));
		$pr->type($provider->findvalue('type'));
		$pr->tuner($provider->findvalue('tuner'));
		$pr->chanid($provider->findvalue('chanid'));
		$pr->description($provider->findvalue('description'));
	}
}

sub store {
	my $self = shift;
	confess "usage: ProviderXML->store(fd)"    unless @_ == 1;
	my $fd = shift;

	my @pl = Provider->listOfProviders();
	foreach my $pr (@pl) {
		my $pr_name = $pr->name();
		my $pr_type = $pr->type();
		my $pr_tuner = $pr->tuner();
		my $pr_chanid = $pr->chanid();
		my $pr_description = $pr->description();
		print $fd "\t<provider name=\"" . $pr_name . "\">\n";
		print $fd "\t\t<type>" . $pr_type . "</type>\n";
		print $fd "\t\t<tuner>" . $pr_tuner . "</tuner>\n";
		print $fd "\t\t<chanid>" . $pr_chanid . "</chanid>\n";
		print $fd "\t\t<description>" . $pr_description . "</description>\n";
		print $fd "\t</provider>\n";
	}
}

1;
