package TunerFactory;

use strict;
use Carp;
use warnings;

require Provider;

require ExternalTunerInfo;
require AnalogueTunerInfo;
require DVB_STunerInfo;

require ExternalTunerInfoXML;
require AnalogueTunerInfoXML;
require DVB_STunerInfoXML;

sub getTunerInfo {
	my $class = shift; # skip class
	my $name = shift;
	foreach my $p (Provider->listOfProviders()) {
		if ($name eq $p->name()) {
			my $tuner = $p->tuner();
			if ($tuner eq 'external') {
				return ExternalTunerInfo->new();
			} elsif ($tuner eq 'analogue') {
				return AnalogueTunerInfo->new();
			} elsif ($tuner eq 'dvb_s') {
				return DVB_STunerInfo->new();
			} else {
				print "no tunerinfo\n";
			}
		}
	}
}

sub getTunerXML {
	my $class = shift; # skip class
	my $name = shift;
	my $tx;
	foreach my $p (Provider->listOfProviders()) {
		if ($name eq $p->name()) {
			my $tuner = $p->tuner();
			if ($tuner eq 'external') {
				$tx = ExternalTunerInfoXML->new();
			} elsif ($tuner eq 'analogue') {
				$tx = AnalogueTunerInfoXML->new();
			} elsif ($tuner eq 'dvb_s') {
				$tx = DVB_STunerInfoXML->new();
			} else {
				print "no tunerinfo\n";
			}
			$tx->name($name);
			return $tx;
		}
	}
}

1;  # so the require or use succeeds
