package TvXML;

use strict;
use Carp;
use warnings;

use XML::LibXML;

require ProviderXML;
require ChannelXML;

sub load {
	my $self = shift;
	confess "usage: TvXML->load(file)"    unless @_ == 1;
	my $file = shift;

	my $parser = XML::LibXML->new();
	my $tree = $parser->parse_file($file);
	my $root = $tree->getDocumentElement;

	ProviderXML->load($root);
	ChannelXML->load($root);

#	print "test:providers=" . Provider->toString() ."\n";
#	print "test:channels=" . Channel->toString() ."\n";
}

sub store {
	my $self = shift;
	confess "usage: TvXML->store(file)"    unless @_ == 1;

	my $file = shift;
	my $fh = new IO::File;
	if ($fh->open($file, "w")) {
		print $fh "<?xml version=\"1.0\"?>\n";
		print $fh "<tv>\n";
		ProviderXML->store($fh);
		ChannelXML->store($fh);
		print $fh "</tv>\n";
		$fh->close;
	}
}

1;
